''***************************************
''*         Ping))) Demo V1.2           *
''* Author:  Chris Savage & Jeff Martin *
''* Copyright (c) 2006 Parallax, Inc.   *
''* See end of file for terms of use.   *    
''* Started: 05-08-2006                 *
''***************************************
''
'' Version 1.2 - Updated March 26, 2008 by Jeff Martin to use updated Debug_LCD.

CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  TO_IN = 73_746                                                                ' Inches

  PING_Pin1 = 16
  Numpings      =3
  
  STRIP_LEN  = 5 
  LED = 14
  CKI = 2                                           ' I/O Pin For PING)))
  CS = 16  ''CS: Clear Screen      
  CE = 11  ''CE: Clear to End of line     
  CB = 12  ''CB: Clear lines Below 

  HM =  1  ''HM: HoMe cursor       
  PC =  2  ''PC: Position Cursor in x,y          
  PX = 14  ''PX: Position cursor in X         
  PY = 15  ''PY: Position cursor in Y         

  NL = 13  ''NL: New Line        
  LF = 10  ''LF: Line Feed       
  ML =  3  ''ML: Move cursor Left          
  MR =  4  ''MR: Move cursor Right         
  MU =  5  ''MU: Move cursor Up          
  MD =  6  ''MD: Move cursor Down
  TB =  9  ''TB: TaB          
  BS =  8  ''BS: BackSpace          
           
  BP =  7  ''BP: BeeP speaker          
  TERM_BAUD     = 115200                              
  off    =  $00_00_00
  Black  =  $00_00_00
  RED   =   $FF_00_00
  GREEN =   $00_FF_00
  BLUE  =   $00_00_FF
  AMBER =   $FF_FF_00

VAR

  long pingmem[numpings + 1]
  long  range1, range2,range3,ping1,ping2,ping3
  
  long clrbuff[6]
OBJ

  ping : "pingdebug"
  PCterminal  : "FullDuplexSerial_2k"
  leds : "jm_ws2812"
  
  
PUB Start  |index, microseconds
   Ping.start (Ping_pin1,numpings,@pingmem)
   PCterminal.start(31, 30, %0000, TERM_BAUD)
   PCterminal.tx (CS)
   
  repeat                                                ' Repeat Forever
    PCterminal.TX (HM)
    PCterminal.TX(NL)                                  ' Position Cursor
    PCterminal.str(string("return from ping1  "))
    pcterminal.dec(@pingmem[0])
    microseconds := (pingmem[0]// (clkfreq / 1_000_000))
    pcterminal.str(string("   microseconds  "))
    pcterminal.dec (microseconds)
    range1 := (microseconds * 1000/TO_IN)
    PCterminal.str(string(" inches "))                              ' Pad For Clarity
    PCterminal.dec (range1)